/*
Tecnisa - Tecnologia em Informtica

Nome: APURAC_TAXAFIXA

Descrio:
   Procedimento para apurao de faturamento de clientes em filiais
   que utilizam o tipo de contrato Taxa Fixa.

Criao:
22/01/2002 - Disnei H. de Moura
Manutno:
01/02/2002 - Alessandra Crisitna - Converso p/ SqlServer

@C:\win_PRJ\SQL\SQLSERVER\6206_FAISTP_ApuTaxaFixa.sql;

--   raise_application_error(-20501,TO_CHAR(@V_VRBRUTITEM)||' - '||TO_CHAR(@V_VRBRUTITEM), True);
*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'APURAC_TAXAFIXA' AND
                 TYPE = 'P' 			         AND
                 U.UID = O.UID             	AND
                 U.NAME = USER)
DROP PROCEDURE APURAC_TAXAFIXA
GO

CREATE PROCEDURE APURAC_TAXAFIXA(
   @P_CDFILIAPUR  VARCHAR(04),
   @P_CDFILIPROC  VARCHAR(04),
   @P_CDCLIENTE   VARCHAR(21),
   @P_DATAINI     DATETIME,
   @P_DATAFIM     DATETIME,
   @P_NRAPURACFAT VARCHAR(10),
   @P_NRLANCTONF  VARCHAR(10),
   @P_IDNFCOMPRA  VARCHAR(01)
) AS

   DECLARE @V_CDEMPRATAC  VARCHAR(02);
   DECLARE @V_CDINSCATAC  VARCHAR(16);
   DECLARE @V_CDEMPROPER  VARCHAR(02);
   DECLARE @V_CDSERIE     VARCHAR(05);
   DECLARE @V_CDIMPOSTO   VARCHAR(02);

   DECLARE @V_CDFILIAPUR  VARCHAR(02);

   DECLARE @V_NRLANCTONF  VARCHAR(10);
   DECLARE @V_VRNOTAFISC  VARCHAR(20);

   DECLARE @V_VRDOTACAO  NUMERIC(16,2);


   DECLARE @V_NRLANCESTQ  VARCHAR(10);

   DECLARE @V_CDPRGENEREV VARCHAR(10);
   DECLARE @V_NMPRGENEREV VARCHAR(50);

   DECLARE @V_DSAJUCTREC  VARCHAR(40);

   DECLARE @V_ENCARGO     VARCHAR(02);

   DECLARE @V_NVPRGENEREV VARCHAR(20);

   DECLARE @V_DSPRPRESERV VARCHAR(40);
   DECLARE @V_VERIGRUPDES VARCHAR(02);
   DECLARE @V_IDTAXAADM   VARCHAR(01);
   DECLARE @V_IDCALCCOMPR VARCHAR(01);
   DECLARE @V_IDRECUIMPOS VARCHAR(01);
   DECLARE @V_DESCDOTACAO VARCHAR(01);
   DECLARE @V_CDAJUSTPADR VARCHAR(02);
   DECLARE @V_CDENCREDITO VARCHAR(02);
   DECLARE @V_CDENCDEBITO VARCHAR(02);
   DECLARE @V_IDGERACORPO VARCHAR(01);


   DECLARE @V_VRBRUTITEM  NUMERIC;
   DECLARE @V_VRIMPOSTOIT NUMERIC;
   DECLARE @V_VRBRUTDESP  NUMERIC;
   DECLARE @V_VRTAXAADM   NUMERIC;
   DECLARE @V_VRPCTXADM   NUMERIC;
   DECLARE @V_VRLIQUFATU  NUMERIC;
   DECLARE @V_PRXDESPESA  NUMERIC;
   DECLARE @V_VRIMPODEBI  NUMERIC;
   DECLARE @V_VRDEBITO    NUMERIC;
   DECLARE @V_VRPERCDESP  NUMERIC;

   DECLARE @V_CDNIVELPROD INTEGER;

   DECLARE @TESTE         NUMERIC;
   DECLARE @V_PRXMRDP     NUMERIC;

/*Varives do cursor C_DELETANF*/
   DECLARE @V_CDFILIAL     VARCHAR(04);
   DECLARE @NRLANCTONF   VARCHAR(10);

/*Varives do cursor C_COMPRA*/
   DECLARE @VRBRUTITEM     NUMERIC;
   DECLARE @VRIMPOSTOIT    NUMERIC;
   DECLARE @VRBRUTDESP     NUMERIC;
   DECLARE @VRDEBITO       NUMERIC;
   DECLARE @NMPRODUTO      NUMERIC;
   DECLARE @CDPRODUTO      NUMERIC;

   DECLARE @CDFILI           VARCHAR(04);
   DECLARE @V_CDDESPADMFAT   VARCHAR(02);
   DECLARE @V_DTLANCDESFAT   DATETIME;
   DECLARE @V_VRLANCDESFAT   NUMERIC(15,5)
   DECLARE @V_CDGRUPOFATUR   VARCHAR(02);
   DECLARE @V_CDPRODUTO      VARCHAR(10);
   DECLARE @V_DSDESPADMFAT   VARCHAR(40);

BEGIN

   SET @V_VRNOTAFISC = 0;

   /* FILIAL QUE EST SENDO APURADA (@P_FILIAL = FILIPROC)*/
   SELECT @V_CDFILIAPUR = MAX(CDFILIAPUR)
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = @P_CDFILIPROC   AND
         NRAPURACFAT = @P_NRAPURACFAT;

   SELECT @V_VRPCTXADM    = CONVERT(NUMERIC,ISNULL(MAX(SUBSTRING(PF.DSPARAMFATFI,31,3)), 0)), /*Percentual de Compras/Revenda*/
          @V_CDEMPRATAC   = MAX(SUBSTRING(PF.DSPARAMFATFI,39,2)),          /*Empresa atacadista*/
          @V_CDEMPROPER   = MAX(SUBSTRING(PF.DSPARAMFATFI,41,2)),          /*Empresa operacional*/
          @V_IDTAXAADM    = MAX(SUBSTRING(PF.DSPARAMFATFI,43,1)),          /*Taxa de Administracao*/
          @V_DSPRPRESERV  = MAX(SUBSTRING(PG.DSPARAMFATGE,22,40)),         /*Descricao para Nota Fiscal*/
          @V_CDPRGENEREV  = RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,125,10))),  /*Codigo da Produto para Revenda*/
          @V_NVPRGENEREV  = RTRIM(MAX(SUBSTRING(PG.DSPARAMFATGE,135,20))), /* Nvel dos produtos a serem gerados*/
          @V_IDCALCCOMPR  = MAX(SUBSTRING(PF.DSPARAMFATFI,49,1)),          /*Calculo Valor Total de Compras*/
          @V_IDRECUIMPOS  = MAX(SUBSTRING(PF.DSPARAMFATFI,37,1)),          /*Recuperao de Impostos*/
          @V_DESCDOTACAO  = MAX(SUBSTRING(PF.DSPARAMFATFI,56,1)),          /*Desconto de Dotao*/
          @V_CDAJUSTPADR  = MAX(SUBSTRING(PF.DSPARAMFATFI,57,2)),          /*Ajuste Padrao*/
          @V_CDENCREDITO  = MAX(SUBSTRING(PF.DSPARAMFATFI,59,2)),          /*Encargo debito*/
          @V_CDENCDEBITO  = MAX(SUBSTRING(PF.DSPARAMFATFI,61,2)),           /*Encargo Credito*/
          @V_VRPERCDESP   = MAX(SUBSTRING(PF.DSPARAMFATFI,63,2))         /*Percentual de Despesas*/
   FROM PARAMFILIAL PF, PARAMGERAL PG
   WHERE PF.CDFILIAL = @V_CDFILIAPUR;

   SELECT @V_NMPRGENEREV = MAX(NMPRODUTO)
   FROM PRODUTO
   WHERE CDPRODUTO  =  @V_CDPRGENEREV;

   SELECT @V_VRNOTAFISC = SUM(VRNOTAFISC)
   FROM NOTAFISCAL N
   WHERE (N.CDFILIAL     = @P_CDFILIAPUR)                  AND
         (N.CDTIPOOPER   = '12')                          AND
         (N.IDENTRSAIDOP = 'S')                           AND
         (N.DTENTRSAID BETWEEN @P_DATAINI AND @P_DATAFIM);

   IF (@V_VRNOTAFISC < 0) BEGIN
      SET @V_VRNOTAFISC = @V_VRNOTAFISC * (-1);
      SET @V_ENCARGO    = @V_CDENCDEBITO;
   END
   ELSE IF (@V_VRNOTAFISC > 0) BEGIN
      SET @V_ENCARGO   =  @V_CDENCREDITO;
   END;

   SELECT @V_CDNIVELPROD = DATALENGTH(MAX(CDPRODUTO))
   FROM PRODUTO
   WHERE CDNVPRODUTO = '1';

   SELECT @V_DSAJUCTREC = MAX(SUBSTRING(DSAJUCTREC,1,20))
   FROM TIPOAJRECEBER
   WHERE @V_CDAJUSTPADR = CDAJUCTREC;

   IF @P_IDNFCOMPRA = 'N' BEGIN

      /*VERIFICA SE EXISTE REGISTRO NA TABELA NOVOCODIGO P/ A SRIE DO MRDP*/

      SELECT @V_PRXMRDP = CONVERT(NUMERIC,ISNULL(MAX(NRSEQUENCIAL),0))
      FROM NOVOCODIGO
      WHERE CDCONTADOR = 'LANCAMENTO DE MRDP';

      /*INCLUI CHAVE SEQUENCIAL PARA A SRIE DO MRDP*/
      IF (@V_PRXMRDP = 0) BEGIN
         INSERT INTO NOVOCODIGO
            (CDCONTADOR, NRSEQUENCIAL)
         VALUES
            ('LANCAMENTO DE MRDP', '00000000000000000001');

         SET @V_PRXMRDP = 1;
      END;

      INSERT INTO MRDPAPUR (CDFILIAL, NRAPURACFAT, NRMRDPAPUR)
      VALUES (@P_CDFILIPROC, @P_NRAPURACFAT, RIGHT('0000000'+(CONVERT(VARCHAR,@V_PRXMRDP)),7));

      UPDATE NOTAFISCAL
      SET CDFILIAPFATU = @P_CDFILIPROC,
          NRAPFATUTNF  = @P_NRAPURACFAT
      WHERE (CDEMPRESA    = @V_CDEMPRATAC) AND
            (CDFILIRECE   = @V_CDFILIAPUR) AND
            (DTENTRSAID BETWEEN  @P_DATAINI AND @P_DATAFIM)    AND
            (CDTIPOOPER   = '01')         AND
            (IDENTRSAIDOP = 'E')          AND
            (IDSTATUS     = 'A')          AND
            (ISNULL(IDSISTEMA,'DFE') IN ('DFE','EST')) AND
            ((NRAPURACFAT IS NULL) OR (NRAPURACFAT = @P_NRAPURACFAT));

   END;

   SELECT @V_CDSERIE = MAX(CDSERIE)
   FROM FILIAL
   WHERE CDFILIAL  = @V_CDFILIAPUR AND
         CDEMPRESA = @V_CDEMPRATAC;

   SELECT @V_CDIMPOSTO = MAX(CDIMPOSTO)
   FROM IMPOSMRDP
   WHERE IDIMPOMRDP = 'P';

   SET @V_NRLANCTONF = @P_NRLANCTONF;

   SET @V_IDGERACORPO = ' ';

   DECLARE C_DELETANF CURSOR FOR
   SELECT CDFILIAL, NRLANCTONF
   FROM NOTAFISCAL
   WHERE CDFILIAL    = @P_CDFILIAPUR AND
         NRAPURACFAT = @P_NRAPURACFAT;

   OPEN C_DELETANF
   FETCH NEXT FROM C_DELETANF INTO @V_CDFILIAL, @NRLANCTONF;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      EXEC DELETA_NF @V_CDFILIAL, @V_NRLANCTONF;

      FETCH NEXT FROM C_DELETANF INTO @V_CDFILIAL, @NRLANCTONF;
   END;
   CLOSE C_DELETANF;
   DEALLOCATE C_DELETANF;

   DECLARE C_NFCOMPRA CURSOR FOR
   SELECT ISNULL(SUM(IP.VRBRUTITEM),0)  AS VRBRUTITEM,
          ISNULL(SUM(II.VRIMPOSTOIT),0) AS VRIMPOSTOIT,
          ISNULL(SUM(DV.VRBRUTITEM),0)  AS VRBRUTDESP,
          ISNULL(SUM(DV.VRIMPOSTOIT),0) AS VRDEBITO,
          PR.NMPRODUTO, PR.CDPRODUTO
   FROM  (SELECT CDPRODUTO, NMPRODUTO
         FROM PRODUTO
         WHERE CDNVPRODUTO = '1') PR,
         NOTAFISCAL N, ITEMPRODUTO IP LEFT JOIN ITEMPROIMPOS II ON
                                        II.CDFILIAL     = IP.CDFILIAL             AND
                                        II.NRLANCTONF   = IP.NRLANCTONF           AND
                                        II.NRSEQITPROD  = IP.NRSEQITPROD          AND
                                        II.CDIMPOSTO    = @V_CDIMPOSTO            AND
                                        II.NRITPROIMPOS = '1'
                                     LEFT JOIN
        (SELECT I.VRBRUTITEM, T.VRIMPOSTOIT,
                CDPRODUTO
         FROM  NOTAFISCAL N, ITEMPRODUTO I LEFT JOIN ITEMPROIMPOS  T ON
                                              (T.CDFILIAL     = I.CDFILIAL)      AND
                                              (T.NRLANCTONF   = I.NRLANCTONF)    AND
                                              (T.NRSEQITPROD  = I.NRSEQITPROD)   AND
                                              (T.CDIMPOSTO    = @V_CDIMPOSTO)    AND
                                              (T.NRITPROIMPOS = '1')
         WHERE (CDEMPRESA    = @V_CDEMPRATAC)         AND
               (CDFILIEMIT   = @V_CDFILIAPUR)         AND
               (DTENTRSAID  <= @P_DATAFIM)            AND
               (CDTIPOOPER   = '06')                 AND
               (IDENTRSAIDOP = 'S')                  AND
               (IDSTATUS IN ('E','A'))               AND
               (N.CDFILIAL        = I.CDFILIAL)      AND
               (N.NRLANCTONF      = I.NRLANCTONF)    AND
               (CHARINDEX(SUBSTRING(I.CDPRODUTO,1,@V_CDNIVELPROD),@V_NVPRGENEREV) > 0)) DV ON
                                                                    DV.CDPRODUTO      = IP.CDPRODUTO

   WHERE N.CDFILIAPFATU     = @P_CDFILIPROC                             AND
         N.NRAPFATUTNF      = @P_NRAPURACFAT                            AND
         IP.CDFILIAL        = N.CDFILIAL                                AND
         IP.NRLANCTONF      = N.NRLANCTONF                              AND
         SUBSTRING(IP.CDSITUTRIBPR,2,2) NOT IN ('10','60')              AND
         CHARINDEX(SUBSTRING(IP.CDPRODUTO,1,@V_CDNIVELPROD), @V_NVPRGENEREV) > 0  AND
         CHARINDEX(SUBSTRING(IP.CDPRODUTO,1,@V_CDNIVELPROD), PR.CDPRODUTO) > 0
   GROUP BY  PR.NMPRODUTO, PR.CDPRODUTO

   UNION ALL

   SELECT ISNULL(SUM(IP.VRBRUTITEM),0)  AS VRBRUTITEM,
          ISNULL(SUM(II.VRIMPOSTOIT),0) AS VRIMPOSTOIT,
          ISNULL(SUM(DV.VRBRUTITEM),0)  AS VRBRUTDESP,
          ISNULL(SUM(DV.VRIMPOSTOIT),0) AS VRDEBITO,
          PR.NMPRODUTO, PR.CDPRODUTO
   FROM   NOTAFISCAL N, PRODUTO PR,
          ITEMPRODUTO IP LEFT JOIN ITEMPROIMPOS II ON
                           II.CDFILIAL     = IP.CDFILIAL      AND
                           II.NRLANCTONF   = IP.NRLANCTONF    AND
                           II.NRSEQITPROD  = IP.NRSEQITPROD   AND
                           II.CDIMPOSTO    = @V_CDIMPOSTO     AND
                           II.NRITPROIMPOS = '1'
                        LEFT JOIN
        (SELECT I.VRBRUTITEM,
                T.VRIMPOSTOIT,
                CDPRODUTO
         FROM  NOTAFISCAL N, ITEMPRODUTO I LEFT JOIN ITEMPROIMPOS  T ON
                                            (T.CDFILIAL     = I.CDFILIAL)      AND
                                            (T.NRLANCTONF   = I.NRLANCTONF)    AND
                                            (T.NRSEQITPROD  = I.NRSEQITPROD)   AND
                                            (T.CDIMPOSTO    = @V_CDIMPOSTO)    AND
                                            (T.NRITPROIMPOS = '1')

         WHERE (CDEMPRESA    = @V_CDEMPRATAC)        AND
               (CDFILIEMIT   = @V_CDFILIAPUR)        AND
               (DTENTRSAID  <= @P_DATAFIM)           AND
               (CDTIPOOPER   = '06')                 AND
               (IDENTRSAIDOP = 'S')                  AND
               (IDSTATUS IN ('E','A'))               AND
               (N.CDFILIAL        = I.CDFILIAL)      AND
               (N.NRLANCTONF      = I.NRLANCTONF)    AND
               (CHARINDEX(SUBSTRING(I.CDPRODUTO,1,@V_CDNIVELPROD), @V_NVPRGENEREV) > 0)) DV ON
                                    DV.CDPRODUTO      = IP.CDPRODUTO

   WHERE N.CDFILIAPFATU     = @P_CDFILIPROC                             AND
         N.NRAPFATUTNF      = @P_NRAPURACFAT                            AND
         IP.CDFILIAL        = N.CDFILIAL                                AND
         IP.NRLANCTONF      = N.NRLANCTONF                              AND
         SUBSTRING(IP.CDSITUTRIBPR,2,2) IN ('10','60')                  AND
         IP.CDPRODUTO       = PR.CDPRODUTO                              AND
         CHARINDEX(SUBSTRING(IP.CDPRODUTO,1,@V_CDNIVELPROD), @V_NVPRGENEREV) > 0
   GROUP BY  PR.NMPRODUTO, PR.CDPRODUTO
   OPEN C_NFCOMPRA;
   FETCH NEXT FROM C_NFCOMPRA INTO @VRBRUTITEM, @VRIMPOSTOIT, @VRBRUTDESP, @VRDEBITO,
                                 @NMPRODUTO,  @CDPRODUTO
   WHILE (@@FETCH_STATUS = 0) BEGIN

   IF (@V_IDGERACORPO <> 'X') BEGIN
         /*Incluso do Corpo da Nota */
        EXEC GERA_NOTAFISCAL_CORPO @P_CDFILIPROC, @V_CDFILIAPUR, @V_CDEMPRATAC, '01',
                                   @V_CDSERIE, @P_CDCLIENTE, @P_DATAFIM, 'FAI',
                                   @V_NRLANCTONF, @V_NRLANCESTQ, 'N', @P_NRAPURACFAT,
                                   @V_NRLANCTONF;

         IF (@V_DESCDOTACAO = '1') AND (@V_VRNOTAFISC <> 0) BEGIN
            EXEC GERA_NOTAFISCAL_ENCARGO @P_CDFILIPROC, @V_NRLANCTONF, @V_ENCARGO, @V_VRNOTAFISC;
         END;
         SET @V_IDGERACORPO = 'X';
      END;

      IF (@V_IDRECUIMPOS = 'S') BEGIN
        SET @V_VRIMPODEBI = ISNULL(@VRIMPOSTOIT,0) - ISNULL(@VRDEBITO,0);
      END
      ELSE BEGIN
        SET @V_VRIMPODEBI = 0;
      END;

      SET @V_VRBRUTITEM  = (@VRBRUTITEM  -  @VRBRUTDESP) +  @V_VRIMPODEBI;

      IF (@V_IDTAXAADM = 'D') BEGIN  /*Por Dentro*/
          SET @V_VRTAXAADM = (@V_VRBRUTITEM / (1 - (@V_VRPCTXADM / 100))) - (@V_VRBRUTITEM);
      END
      ELSE BEGIN                      /*Por Fora*/
          SET @V_VRTAXAADM = (@V_VRBRUTITEM * (@V_VRPCTXADM / 100));
      END;

      IF (@V_IDCALCCOMPR = '1') BEGIN
         SET @V_VRLIQUFATU = (@V_VRBRUTITEM + ISNULL(@V_VRTAXAADM,0));
      END
      ELSE BEGIN
         SET @V_VRLIQUFATU =  ISNULL(@V_VRTAXAADM,0);
      END;

      /*Incluso dos itens da nota fiscal*/
      EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRGENEREV,
                                   @CDPRODUTO, @NMPRODUTO, 1, @V_VRLIQUFATU, 0,
                                   NULL, NULL, NULL, NULL,
                                   NULL, NULL;

      FETCH NEXT FROM C_COMPRA INTO @VRBRUTITEM, @VRIMPOSTOIT, @VRBRUTDESP, @VRDEBITO,
                                    @NMPRODUTO,  @CDPRODUTO
   END;
   CLOSE C_NFCOMPRA;
   DEALLOCATE C_NFCOMPRA;

   DECLARE C_DESPADMFATUR CURSOR FOR
   SELECT L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT, L.VRLANCDESFAT,
          D.CDGRUPOFATUR, D.CDPRODUTO, D.DSDESPADMFAT
   FROM LANCDESPFATU L,  DESPADMFATUR D
   WHERE (L.CDFILIAL     = @P_CDFILIAPUR)                       AND
         (D.CDDESPADMFAT = L.CDDESPADMFAT)                      AND
         (L.DTLANCDESFAT BETWEEN @P_DATAINI AND @P_DATAFIM)
   GROUP BY D.CDGRUPOFATUR, L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT, L.VRLANCDESFAT,
            D.CDPRODUTO, D.DSDESPADMFAT;
   OPEN C_DESPADMFATUR;
   FETCH NEXT FROM C_DESPADMFATUR INTO @CDFILI,         @V_CDDESPADMFAT, @V_DTLANCDESFAT, @V_VRLANCDESFAT,
                                       @V_CDGRUPOFATUR, @V_CDPRODUTO,    @V_DSDESPADMFAT;

   WHILE (@@FETCH_STATUS = 0) BEGIN

   IF (@V_IDTAXAADM = 'D') BEGIN  /*Por Dentro*/
         SET @V_VRTAXAADM = ((@V_VRLANCDESFAT / (1 - (@V_VRPCTXADM / 100)))  +  (@V_VRLANCDESFAT * (@V_VRPERCDESP / 100))) - (@V_VRLANCDESFAT);
      END
      ELSE BEGIN                    /*Por Fora*/
         SET @V_VRTAXAADM = ((@V_VRLANCDESFAT * (@V_VRPCTXADM / 100)) +  (@V_VRLANCDESFAT * (@V_VRPERCDESP / 100)));
      END;

      SET @V_VRLIQUFATU = (@V_VRLANCDESFAT + ISNULL(@V_VRTAXAADM,0));

      /*Incluso dos itens da nota fiscal*/
      EXEC GERA_NOTAFISCAL_PRODUTO @P_CDFILIPROC, @V_NRLANCTONF, @V_CDPRODUTO,
                                   @V_CDDESPADMFAT, @V_DSDESPADMFAT, 1, @V_VRLIQUFATU, 0,
                                   NULL, NULL, NULL, NULL,
                                   NULL, NULL;

      UPDATE LANCDESPFATU
      SET CDFILILANC = @P_CDFILIPROC,
          NRLANCTONF = @V_NRLANCTONF
      WHERE (CDFILIAL = @P_CDFILIAPUR)                AND
            (CDDESPADMFAT = @V_CDDESPADMFAT)          AND
            (DTLANCDESFAT BETWEEN @P_DATAINI AND @P_DATAFIM);
   FETCH NEXT FROM C_DESPADMFATUR INTO @CDFILI,         @V_CDDESPADMFAT, @V_DTLANCDESFAT, @V_VRLANCDESFAT,
                                       @V_CDGRUPOFATUR, @V_CDPRODUTO,    @V_DSDESPADMFAT;

   END;
   CLOSE C_DESPADMFATUR;
   DEALLOCATE C_DESPADMFATUR;

   IF ((@V_DESCDOTACAO = '2') AND (@V_VRNOTAFISC <> 0)) BEGIN
      INSERT INTO AJCTRECEBER
      (CDFILIAL,    NRLANCTONF,  DTAJUSTEREC, CDAJUCTREC,
       DSAJUSTEREC, VRAJUSTEREC, NRSEQVENREC, NRPARCELAREC)
      (SELECT MAX(CDFILIAL),  MAX(NRLANCTONF), GETDATE() , @V_CDAJUSTPADR,
           @V_DSAJUCTREC,   @V_VRNOTAFISC,    MAX(NRSEQVENREC), MAX(NRPARCELAREC)
        FROM CONTARECEBER
        WHERE (CDFILIAL    =  @P_CDFILIPROC)  AND
              (NRLANCTONF  =  @V_NRLANCTONF));

   END;
   IF (@V_IDGERACORPO = 'X') BEGIN
      EXEC GERA_NOTAFISCAL_FECHAMENTO @P_CDFILIPROC, @V_NRLANCTONF;
   END;
END;
GO