<?php
namespace Teknisa\Model\Gestaopessoas\Entities;

use HCM\FPA\Entity\FpaGrpitemEntity;

class FpaGrpitem extends \Teknisa\Model\Gestaopessoas\Entities\Base\FpaGrpitem {
    
    public function calculaValor($valor){
        $percentual = $this->getVrpercent();
        if ($percentual !== 100 && empty($percentual) === false) {
            $valor = ($valor * $percentual) / 100;
        }

        $multiplicador = $this->getVrmultiplic();
        if ($multiplicador !== 1 && empty($multiplicador) === false) {
            $valor = $valor * $multiplicador;
        }

        $divisor = $this->getVrdivide();
        if ($divisor !== 1 && empty($divisor) === false) {
            $valor = $valor / $divisor;
        }

        $piso = $this->getVrpisoevento();
        if ($valor < $piso) {
            $valor = $piso;
        }

        $teto = $this->getVrtetoevento();
        if ($valor > $teto){
            $valor = $teto;
        }

        return (float)$valor;
    }

    public function determinaReferencia(){
        switch($this->getIdrefgerar()){
        case FpaGrpitemEntity::IDREFGERAR_PERCENTUAL:
            $referencia = $this->getVrpercent();
            break;

        case FpaGrpitemEntity::IDREFGERAR_MULTIPLICADOR:
            $referencia = $this->getVrmultiplic();
            break;

        case FpaGrpitemEntity::IDREFGERAR_DIVISOR:
            $referencia = $this->getVrdivide();
            break;

        case FpaGrpitemEntity::IDREFGERAR_NENHUM:
            $referencia = $this->getVrreffixo();
            break;
        }
        return $referencia;
    }
}